Json::Value g_json;
[Setting name="Manifest" category="General" description="The URL of the manifest file that contains all images"]
string  Setting_Manifest_URL = "https://openplanet.dev/plugin/betterloadingscreen/config/loading_screens";

[Setting category="General" name="Language" description="Define the language for the plugin"]
LanguageSetting Settings_displayMode = Fr;

enum LanguageSetting {
    EnUs = 0,
    Fr = 1
}

bool g_wasShow = false;
uint g_screenValue = 0;
UI::Texture@ m_loading_icon;
UI::Font@ m_text_font_big;
float m_loading_current_rotation = 0;

void Render()
{
   auto loadProgress = GetApp().LoadProgress;
	if (loadProgress is null || loadProgress.State == NGameLoadProgress::EState::Disabled) {
      if(g_wasShow) {
         g_screenValue = g_screenValue + 1;
         if(g_screenValue > g_json.get_Length() - 1) {
            g_screenValue = 0;
         }
         PreloadImage(g_screenValue);
      }
      g_wasShow = false;
		return;
	}
   auto img = Images::CachedFromURL(g_json[g_screenValue]);
   UI::DrawList@ drawList = UI::GetBackgroundDrawList();

   if(img.m_texture !is null) {
      drawList.AddImage(img.m_texture, vec2(
         0, 0
      ), vec2(
         Draw::GetWidth(), Draw::GetHeight()
      ));
   }

   // Loading spinner
   auto loading_icon_position = vec2(0.475, 0.80) * vec2(Draw::GetWidth(),  Draw::GetHeight());
   auto loading_icon_size = vec2(0.052, 0.09245) * vec2(Draw::GetWidth(),  Draw::GetHeight());
   m_loading_current_rotation = m_loading_current_rotation + 0.04f;
   drawList.AddImage(@m_loading_icon, 
      loading_icon_position,
      loading_icon_size,
      0xffffffff,
      m_loading_current_rotation,
      loading_icon_size / 2
   );

   // Loading text
   auto loading_text_position = vec2(0.43, 0.91) * vec2(Draw::GetWidth(),  Draw::GetHeight());
   auto loading_text_size = vec2(0.05, 0.083) * vec2(Draw::GetWidth(),  Draw::GetHeight());
   string loading_text = "Loading ...";
   switch(Settings_displayMode) {
      case Fr:
      loading_text = "Chargement ...";
      loading_text_position = vec2(0.40, 0.91) * vec2(Draw::GetWidth(),  Draw::GetHeight());
      break;
   }
   drawList.AddText(loading_text_position,
      vec4(1, 1, 1, 1),
      loading_text,
      @m_text_font_big,
      Draw::GetHeight() * 0.06
   );

   g_wasShow = true;
}

void PreloadImage(uint index) {
   Images::CachedFromURL(g_json[index]);
}

void Main()
{
   @m_loading_icon = UI::LoadTexture("loading_icon.png");
   @m_text_font_big = UI::LoadFont("LEMONMILK-Medium.otf", 77);

   print("Downloading loading screens json ..");
   auto response = Net::HttpGet(Setting_Manifest_URL);
   while (!response.Finished()) {
      yield();
   }

   g_json = Json::Parse(response.String());

   g_screenValue = Math::Rand(0, g_json.get_Length());
   PreloadImage(g_screenValue);
   yield();
}